/* ---------- */
/* najiconv.c */
/* ---------- */

/* naji simple conversion functions */

/* this  .c  file is a part */
/* of libnaji version 0.3.0 */

/* libnaji is based on   */
/* the original najitool */

/* both najitool and libnaji */
/* are public domain and are */
/* made by the same author   */
/* please read license.txt   */

/* made by NECDET COKYAZICI  */

#include "libnaji.h"

void bin2text(char *namein, char *nameout)
{
int a=0;

najin(namein);
najout(nameout);

        loop
        {
        a = fgetc(naji_input);
        if (a == EOF) endloop;

    if ( ( (a > 31) && (a < 127) ) ||
         ( (a == '\n') ) ||
         ( (a == '\r') ) ||
         ( (a == '\t') )
        )
    
        fputc(a, naji_output);
        }

najinclose();
najoutclose();
}


/* todo: remove the first or last bytes in every line of a file */
/* in the amount of bytes you specify */

/* does the opposite thing that skipchar does */
void onlychar(char *namein, char *nameout, char *toshow)
{
int show = NAJI_TRUE;
int a=0;
int i=0;
int l=0;


najin(namein);
najout(nameout);

    l = strlen(toshow);

        loop
        {
        a = fgetc(naji_input);
        if (a == EOF) endloop;

        show = NAJI_FALSE;

        for (i=0; i<l; i++)
        if (a == toshow[i])
        show = NAJI_TRUE;

        if (show == NAJI_TRUE)
        fputc(a, naji_output);

        }
najinclose();
najoutclose();
}



void repchar(char *namein, char *nameout, unsigned int repeat)
{
int a=0;
unsigned int i=0;

najin(namein);
najout(nameout);

repeat++;

        loop
        {
        a = fgetc(naji_input);
        if (a == EOF) endloop;

        for (i=0; i<repeat; i++)
        fputc(a, naji_output);
        }

najinclose();
najoutclose();
}




void repcharp(char *namein, char *nameout, unsigned int start)
{
int a=0;
unsigned int i=0;

najin(namein);
najout(nameout);

start++;

        loop
        {
        a = fgetc(naji_input);
        if (a == EOF) endloop;

        for (i=0; i<start; i++)
        fputc(a, naji_output);

        start++;
        }

najinclose();
najoutclose();
}




void skipchar(char *namein, char *nameout, char *toskip)
{
int skip = NAJI_FALSE;
int a=0;
int i=0;
int l=0;


najin(namein);
najout(nameout);

    l = strlen(toskip);

        loop
        {
        a = fgetc(naji_input);
        if (a == EOF) endloop;
        skip = NAJI_FALSE;

        for (i=0; i<l; i++)
        if (a == toskip[i])
        skip = NAJI_TRUE;

        if (skip == NAJI_FALSE)
        fputc(a, naji_output);
        }
najinclose();
najoutclose();
}



/* reverses the file, note: this is usually not needed for */
/* right to left languages like arabic, its stored the same way as */
/* normal ascii but the software just displays it differently */
/* you might want to use this function for your own graphics or */
/* or encryption format */
void freverse(char *namein, char *nameout)
{
int a=0;
long pos;

najin(namein);
najout(nameout);

    pos = najinsize();

    loop
    {
    pos--;
    if (pos < 0) endloop;

    fseek(naji_input, pos, SEEK_SET);

    a = fgetc(naji_input);
    fputc(a, naji_output);
    }

najinclose();
najoutclose();
}




/* reverses every line in a file */
/* note: this has a bug which i should fix later */
/* the last line does'nt get reversed proaplly */
void revlines(char *namein, char *nameout)
{
char buffer[1000];

najin(namein);
najout(nameout);

  while (!feof(naji_input))
  {
  fgets(buffer, 990, naji_input);
  sreverse(buffer);
  fputs(buffer, naji_output);
  }

najinclose();
najoutclose();
}




/* very useful function, especially for source code. */
/* converts dos format text files to unix format text files */
void dos2unix(char *namein, char *nameout)
{
int a=0;

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    if (a == EOF) endloop;
    
    if (a != '\r')
    fputc(a, naji_output);
    }

najinclose();
najoutclose();
}

/* very useful function, especially for source code. */
/* converts unix format text files to dos format text files */
void unix2dos(char *namein, char *nameout)
{
int a;

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    if (a == EOF) endloop;

    if (a != '\n')
    fputc(a, naji_output);
    
    if (a == '\n')
    {
    fputc('\r', naji_output);
    fputc('\n', naji_output);
    }
    
    }

najinclose();
najoutclose();
}


/* todo: i should make spacetab, which   */
/* should convert spaces to tabs as well */

void tabspace(int spaces, char *namein, char *nameout)
{
int a;
int i;

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    if (a == EOF) endloop;

    if (a != '\t')
    fputc(a, naji_output);
    
    if (a == '\t')
    {
    for (i=0; i<spaces; i++)
    fputc(' ', naji_output);
    }
    
    }

najinclose();
najoutclose();
}

